Program VbMuis;
Uses Dos, Crt, Graph, BgiDriv, BgiFont;

{--------------------------------------------------------------------}
{ Voorbeeldprogramma in Turbo Pascal. Dit programma demonstreert het }
{ gebruik van de zelfgedefinieerde muiscursor.                       }
{--------------------------------------------------------------------}

CONST
  MuisTabel : Array[1..34] of Word=( 65535, 50175, 32769, 1, 32769,
                                     50175, 65535, 1023, 63487, 511,
                                     56319, 47103, 0, 57343, 32768,
                                     65535, 0, 6144, 12288, 32764,
                                     12288, 6144, 0, 511, 173,
                                     175, 188, 0, 0, 0,
                                     0, 0, 0, 0);

Var
  Dxa   : Word;                           { Offset van de tabel      }
  Esa   : Word;                           { Segment van de tabel     }
  HsVer : Word;                           { Hot-Spot vertikaal       }
  HsHor : Word;                           { Hot-Spot horizontaal     }

Function InitMouse: Boolean;
Var State:Integer;
Begin
  Asm
    push ds
    mov  ax,0
    int  $33
    mov  state,ax
    pop  ds
  End;
  If (state=-1) then
  Begin
    InitMouse:=True;
  End
    Else
      InitMouse:=False;
End;

Procedure ShowMouse;
Begin
  Asm
    push ds
    mov  ax, 1
    int  $33
    pop  ds
  End;
End;

Procedure HideMouse;
Begin
  Asm
    push ds
    mov  ax,2
    int  $33
    pop  ds
  End;
End;

Function LeftButtonPressed: Boolean;
Var LeftButStat: Word;
Begin
  Asm
    push ds
    mov  ax,5
    mov  bx,0
    int  $33
    mov  LeftButStat,ax
    pop  ds
  End;
  Case LeftButStat of
    1,3,5,7: LeftButtonPressed:=True;
    Else
      LeftButtonPressed:=False;
  End;
End;

Function MidButtonPressed: Boolean;
Var MidButStat:Word;
Begin
  Asm
    push ds
    mov  ax,5
    mov  bx,2
    int  $33
    mov  MidButStat,ax
    pop  ds
  End;
  Case MidButStat of
    4,5,6,7: MidButtonPressed:=True;
    Else
      MidButtonPressed:=False;
  End;
End;

Function RightButtonPressed:Boolean;
Var RightButStat:Word;
Begin
  Asm
    push ds
    mov  ax,5
    mov  bx,1
    int  $33
    mov  RightButStat,ax
    pop  ds
  End;
  Case RightButStat of
    2,3,6,7: RightButtonPressed:=True;
    Else
      RightButtonPressed:=False;
  End;
End;

Function MouseX: Integer;
Var x:Integer;
Begin
  Asm
    push ds
    mov  ax, 3
    mov  bx, 0
    int  $33
    mov  x, cx
    pop  ds
  End;
  MouseX:=x;
End;

Function MouseY:Integer;
Var y:Integer;
Begin
  Asm
    push ds
    mov  ax, 3
    mov  bx, 0
    int  $33
    mov  y, dx
    pop  ds
  End;
  MouseY:=y;
End;

Procedure MouseSetX(x1,x2:Word);
Var
  Xmin,Xmax:Word;
Begin
  Xmin:=x1;
  Xmax:=x2;
  Asm
    push ds
    mov  ax,7
    mov  cx,Xmin
    mov  dx,Xmax
    int  $33
    pop  ds
  End;
End;

Procedure MouseSetY(y1,y2: Word);
Var
  Ymin,Ymax:Word;
Begin
  Ymin:=y1;
  Ymax:=y2;
  Asm
    push ds
    mov  ax,8
    mov  cx,Ymin
    mov  dx,Ymax
    int  $33
    pop  ds
  End;
End;

Procedure MouseXy(x,y:Word);
Var
  Mx,My:Word;
Begin
  Asm
    push ds
    mov  ax,4
    mov  cx,Mx
    mov  dx,My
    int  $33
    pop  ds
  End;
End;

Procedure MouseWindow (x1, y1, x2, y2: Integer);
Begin
  Asm
    push ds
    mov  ax, $7
    mov  cx, x1
    mov  dx, x2
    int  $33
    mov  ax, $8
    mov  cx, y1
    mov  dx, y2
    int  $33
    pop  ds
  End;
End;

Procedure MouseLoadCursor;
Begin
  Asm
    push ds
    mov  bx, HsVer
    mov  cx, HsHor
    mov  ax, ESa
    mov  es, ax
    mov  ax, DXa
    mov  dx, ax
    mov  ax, 9
    int  $33
    pop ds
  End;
End;

Procedure GraphScreen;
Var
  x, y,
  Driver,
  Mode,
  ErrorCode: Integer;
Begin
  if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
  Begin
    RestoreCrtMode;
    Writeln('*** Graphics Error initializing EGA ***');
    Writeln;
    Writeln('Program halted. (RegisterBgiDriver)');
    Halt(1);
  End;
  Driver:=Ega;
  Mode:=EgaHi;
  InitGraph(Driver, Mode, '');
  ErrorCode:=GraphResult;
  If ErrorCode<>GrOk then
  Begin
    RestoreCrtMode;
    Writeln('*** Graphics Error initializing EGA ***');
    Writeln;
    Writeln('Program halted. (InitGraph)');
    Halt(1);
  End;
  If Not(InitMouse) then
  Begin
    RestoreCrtMode;
    Writeln('*** Error initializing Mouse ***');
    Writeln;
    Writeln('Program halted.');
    Halt(1);
  End;
  HsHor :=  MuisTabel[33];
  HsVer :=  MuisTabel[34];

  MouseLoadCursor;
  SetFillStyle(SolidFill,Red);
  Bar(1,1,640,350);
  SetColor(LightCyan);
  OuttextXy(10,10,' Press RIGHT mousebutton to end this demo.');
  SetColor(14);
  ShowMouse;
  repeat
    If LeftButtonPressed Then
    Begin
      HideMouse;
      While LeftButtonPressed Do
      Begin
        HideMouse;
        x:=MouseX;
        y:=MouseY;
        Line(x-5,y-5,x+5,y+5);
        Line(x+5,y-5,x-5,y+5);
        ShowMouse;
      End;
      ShowMouse;
    End;
  until RightButtonPressed;
End;

Begin
  Dxa:=Ofs(MuisTabel[1]);
  Esa:=Seg(MuisTabel[1]);
  HsVer:=0;
  HsHor:=0;
  GraphScreen;
  CloseGraph;
  RestoreCrtMode;
End.
